<?php

/**
 * Tiny Coffee Options Data
 */
class Tiny_Coffee_Options_Data {

	/**
	 * Holds Font Aswesome icon names
	 *
	 * @var array
	 * @access protected
	 */
	protected static $icons = array(
		"glass","martini","drink","bar","alcohol","liquor","music","note","sound","search","magnify","zoom","enlarge","bigger","envelope-o","email","support","e-mail","letter","mail","notification","heart","love","like","favorite","star","award","achievement","night","rating","score","star-o","user","person","man","head","profile","film","movie","th-large","blocks","squares","boxes","th","th-list","ul","ol","checklist","finished","completed","done","todo","check","checkmark","agree","accept","confirm","times","remove","close","exit","x","search-plus","search-minus","minify","smaller","power-off","on","signal","cog","gear","settings","trash-o","garbage","delete","trash","hide","home","main","house","file-o","new","page","pdf","document","clock-o","watch","timer","late","timestamp","road","street","download","import","arrow-circle-o-down","arrow-circle-o-up","inbox","play-circle-o","repeat","rotate-right","redo","forward","refresh","reload","list-alt","lock","protect","admin","flag","report","notify","headphones","listen","volume-off","mute","volume-down","lower","quieter","volume-up","higher","louder","qrcode","scan","barcode","tag","label","tags","labels","book","read","documentation","bookmark","save","print","camera","photo","picture","record","font","text","bold","italic","italics","text-height","text-width","align-left","align-center","middle","align-right","align-justify","list","outdent","dedent","indent","video-camera","picture-o","image","pencil","write","edit","update","map-marker","map","pin","location","coordinates","localize","address","travel","where","place","adjust","contrast","tint","raindrop","pencil-square-o","share-square-o","social","send","check-square-o","arrows","move","reorder","resize","step-backward","rewind","previous","beginning","start","first","fast-backward","backward","play","playing","pause","wait","stop","block","box","square","next","fast-forward","end","last","step-forward","eject","chevron-left","bracket","back","chevron-right","plus-circle","add","create","expand","minus-circle","times-circle","check-circle","question-circle","help","information","unknown","info-circle","more","details","crosshairs","picker","times-circle-o","check-circle-o","ban","abort","arrow-left","arrow-right","arrow-up","arrow-down","share","mail-forward","compress","combine","merge","plus","minus","collapse","asterisk","exclamation-circle","warning","error","problem","alert","gift","present","leaf","eco","nature","fire","flame","hot","popular","eye","show","visible","views","eye-slash","toggle","visiblity","exclamation-triangle","plane","trip","destination","airplane","fly","mode","calendar","date","time","when","random","sort","comment","speech","magnet","chevron-up","chevron-down","retweet","shopping-cart","checkout","buy","purchase","payment","folder","folder-open","arrows-v","arrows-h","bar-chart","bar-chart-o","graph","twitter-square","tweet","social network","facebook-square","camera-retro","key","unlock","password","cogs","gears","comments","conversation","notes","thumbs-o-up","approve","thumbs-o-down","dislike","disapprove","disagree","star-half","heart-o","sign-out","log out","logout","leave","arrow","linkedin-square","thumb-tack","marker","external-link","open","sign-in","enter","join","sign up","sign in","signin","signup","trophy","winner","game","github-square","octocat","upload","lemon-o","phone","call","voice","number","square-o","bookmark-o","phone-square","twitter","facebook","facebook-f","github","credit-card","money","debit","rss","feed","blog","hdd-o","harddrive","hard drive","storage","bullhorn","announcement","broadcast","bell","reminder","certificate","badge","hand-o-right","point","right","hand-o-left","left","hand-o-up","hand-o-down","arrow-circle-left","arrow-circle-right","arrow-circle-up","arrow-circle-down","globe","world","planet","earth","global","translate","all","language","country","wrench","fix","tasks","progress","loading","downloading","downloads","filter","funnel","options","briefcase","work","business","office","luggage","bag","arrows-alt","users","group","people","profiles","persons","link","chain","cloud","flask","science","beaker","experimental","labs","scissors","cut","files-o","copy","duplicate","paperclip","attachment","floppy-o","bars","navicon","menu","drag","list-ul","list-ol","numbers","strikethrough","underline","table","data","excel","spreadsheet","magic","wizard","automatic","autocomplete","truck","shipping","pinterest","pinterest-square","google-plus-square","google-plus","cash","caret-down","dropdown","caret-up","caret-left","caret-right","columns","split","panes","unsorted","order","sort-desc","sort-down","sort-asc","sort-up","envelope","linkedin","undo","rotate-left","gavel","legal","tachometer","dashboard","comment-o","comments-o","bolt","flash","lightning","weather","sitemap","directory","hierarchy","organization","umbrella","clipboard","paste","lightbulb-o","idea","inspiration","exchange","cloud-download","cloud-upload","user-md","doctor","medical","nurse","stethoscope","suitcase","baggage","bell-o","coffee","morning","mug","breakfast","tea","cafe","cutlery","food","restaurant","spoon","knife","dinner","eat","file-text-o","building-o","apartment","hospital-o","building","ambulance","medkit","first aid","firstaid","fighter-jet","quick","fast","beer","stein","h-square","hospital","hotel","plus-square","angle-double-left","laquo","quote","angle-double-right","raquo","angle-double-up","angle-double-down","angle-left","angle-right","angle-up","angle-down","desktop","monitor","screen","computer","demo","device","laptop","tablet","ipad","mobile","mobile-phone","cell phone","cellphone","iphone","circle-o","quote-left","quote-right","spinner","circle","dot","reply","mail-reply","github-alt","folder-o","folder-open-o","smile-o","emoticon","happy","satisfied","frown-o","sad","meh-o","neutral","gamepad","controller","keyboard-o","type","input","flag-o","flag-checkered","terminal","command","prompt","code","html","brackets","reply-all","mail-reply-all","star-half-o","star-half-empty","star-half-full","location-arrow","crop","code-fork","git","fork","vcs","svn","rebase","version","chain-broken","unlink","question","info","exclamation","superscript","exponential","subscript","eraser","puzzle-piece","addon","add-on","section","microphone","microphone-slash","shield","calendar-o","fire-extinguisher","rocket","app","maxcdn","chevron-circle-left","chevron-circle-right","chevron-circle-up","chevron-circle-down","html5","css3","anchor","unlock-alt","bullseye","target","ellipsis-h","dots","ellipsis-v","rss-square","play-circle","ticket","pass","minus-square","minus-square-o","level-up","level-down","check-square","pencil-square","external-link-square","share-square","compass","safari","caret-square-o-down","toggle-down","caret-square-o-up","toggle-up","caret-square-o-right","toggle-right","eur","euro","gbp","usd","dollar","inr","rupee","jpy","cny","rmb","yen","rub","ruble","rouble","krw","won","btc","bitcoin","file","file-text","sort-alpha-asc","sort-alpha-desc","sort-amount-asc","sort-amount-desc","sort-numeric-asc","sort-numeric-desc","thumbs-up","thumbs-down","youtube-square","video","youtube","xing","xing-square","youtube-play","dropbox","stack-overflow","instagram","flickr","adn","bitbucket","bitbucket-square","tumblr","tumblr-square","long-arrow-down","long-arrow-up","long-arrow-left","long-arrow-right","apple","osx","windows","android","linux","tux","dribbble","skype","foursquare","trello","female","woman","male","gratipay","gittip","sun-o","lighter","brighten","day","moon-o","darker","archive","bug","vk","weibo","renren","pagelines","leaves","tree","plant","stack-exchange","arrow-circle-o-right","arrow-circle-o-left","caret-square-o-left","toggle-left","dot-circle-o","wheelchair","handicap","accessibility","accessibile","vimeo-square","try","turkish-lira","plus-square-o","space-shuttle","slack","envelope-square","wordpress","openid","university","institution","bank","graduation-cap","mortar-board","yahoo","google","reddit","reddit-square","stumbleupon-circle","stumbleupon","delicious","digg","pied-piper","pied-piper-alt","drupal","joomla","fax","child","paw","cube","cubes","behance","behance-square","steam","steam-square","recycle","car","automobile","vehicle","taxi","cab","spotify","deviantart","soundcloud","database","file-pdf-o","file-word-o","file-excel-o","file-powerpoint-o","file-image-o","file-photo-o","file-picture-o","file-archive-o","file-zip-o","file-audio-o","file-sound-o","file-video-o","file-movie-o","file-code-o","vine","codepen","jsfiddle","life-ring","life-bouy","life-buoy","life-saver","circle-o-notch","rebel","ra","empire","ge","git-square","hacker-news","tencent-weibo","qq","weixin","wechat","paper-plane","paper-plane-o","send-o","history","circle-thin","genderless","header","paragraph","sliders","share-alt","share-alt-square","bomb","futbol-o","soccer-ball-o","tty","binoculars","plug","slideshare","twitch","yelp","newspaper-o","wifi","calculator","paypal","google-wallet","cc-visa","cc-mastercard","cc-discover","cc-amex","cc-paypal","cc-stripe","bell-slash","bell-slash-o","copyright","at","eyedropper","paint-brush","birthday-cake","area-chart","pie-chart","line-chart","lastfm","lastfm-square","toggle-off","toggle-on","bicycle","bike","bus","ioxhost","angellist","cc","ils","shekel","sheqel","meanpath","buysellads","connectdevelop","dashcube","forumbee","leanpub","sellsy","shirtsinbulk","simplybuilt","skyatlas","cart-plus","shopping","cart-arrow-down","diamond","gem","gemstone","ship","boat","sea","user-secret","whisper","spy","incognito","motorcycle","street-view","heartbeat","ekg","venus","mars","mercury","transgender","transgender-alt","venus-double","mars-double","venus-mars","mars-stroke","mars-stroke-v","mars-stroke-h","neuter","facebook-official","pinterest-p","whatsapp","server","user-plus","user-times","bed","viacoin","train","subway","medium"
		// 'coffee', 'beer', 'glass', 'money', 'music', 'search', 'envelope-o',
		// 'heart', 'star', 'star-o', 'user', 'film', 'th-large', 'th', 'th-list',
		// 'check', 'times', 'search-plus', 'search-minus', 'power-off', 'signal',
		// 'cog', 'trash-o', 'home', 'file-o', 'clock-o', 'road', 'download',
		// 'arrow-circle-o-down', 'arrow-circle-o-up', 'inbox', 'play-circle-o',
		// 'repeat', 'refresh', 'list-alt', 'lock', 'flag', 'headphones',
		// 'volume-off', 'volume-down', 'volume-up', 'qrcode', 'barcode', 'tag',
		// 'tags', 'book', 'bookmark', 'print', 'camera', 'font', 'bold',
		// 'italic', 'text-height', 'text-width', 'align-left', 'align-center',
		// 'align-right', 'align-justify', 'list', 'outdent', 'indent',
		// 'video-camera', 'picture-o', 'pencil', 'map-marker', 'adjust', 'tint',
		// 'pencil-square-o', 'share-square-o', 'check-square-o', 'arrows',
		// 'step-backward', 'fast-backward', 'backward', 'play', 'pause', 'stop',
		// 'forward', 'fast-forward', 'step-forward', 'eject', 'chevron-left',
		// 'chevron-right', 'plus-circle', 'minus-circle', 'times-circle',
		// 'check-circle', 'question-circle', 'info-circle', 'crosshairs',
		// 'times-circle-o', 'check-circle-o', 'ban', 'arrow-left', 'arrow-right',
		// 'arrow-up', 'arrow-down', 'share', 'expand', 'compress', 'plus',
		// 'minus', 'asterisk', 'exclamation-circle', 'gift', 'leaf', 'fire',
		// 'eye', 'eye-slash', 'exclamation-triangle', 'plane', 'calendar',
		// 'random', 'comment', 'magnet', 'chevron-up', 'chevron-down', 'retweet',
		// 'shopping-cart', 'folder', 'folder-open', 'arrows-v', 'arrows-h',
		// 'bar-chart-o', 'twitter-square', 'facebook-square', 'camera-retro',
		// 'key', 'cogs', 'comments', 'thumbs-o-up', 'thumbs-o-down', 'star-half',
		// 'heart-o', 'sign-out', 'linkedin-square', 'thumb-tack',
		// 'external-link', 'sign-in', 'trophy', 'github-square', 'upload',
		// 'lemon-o', 'phone', 'square-o', 'bookmark-o', 'phone-square',
		// 'twitter', 'facebook', 'github', 'unlock', 'credit-card', 'rss',
		// 'hdd-o', 'bullhorn', 'bell', 'certificate', 'hand-o-right',
		// 'hand-o-left', 'hand-o-up', 'hand-o-down', 'arrow-circle-left',
		// 'arrow-circle-right', 'arrow-circle-up', 'arrow-circle-down', 'globe',
		// 'wrench', 'tasks', 'filter', 'briefcase', 'arrows-alt', 'users',
		// 'link', 'cloud', 'flask', 'scissors', 'files-o', 'paperclip',
		// 'floppy-o', 'square', 'bars', 'list-ul', 'list-ol', 'strikethrough',
		// 'underline', 'table', 'magic', 'truck', 'pinterest',
		// 'pinterest-square', 'google-plus-square', 'google-plus', 'caret-down',
		// 'caret-up', 'caret-left', 'caret-right', 'columns', 'sort', 'sort-asc',
		// 'sort-desc', 'envelope', 'linkedin', 'undo', 'gavel', 'tachometer',
		// 'comment-o', 'comments-o', 'bolt', 'sitemap', 'umbrella', 'clipboard',
		// 'lightbulb-o', 'exchange', 'cloud-download', 'cloud-upload', 'user-md',
		// 'stethoscope', 'suitcase', 'bell-o', 'cutlery', 'file-text-o',
		// 'building-o', 'hospital-o', 'ambulance', 'medkit', 'fighter-jet',
		// 'h-square', 'plus-square', 'angle-double-left', 'angle-double-right',
		// 'angle-double-up', 'angle-double-down', 'angle-left', 'angle-right',
		// 'angle-up', 'angle-down', 'desktop', 'laptop', 'tablet', 'mobile',
		// 'circle-o', 'quote-left', 'quote-right', 'spinner', 'circle', 'reply',
		// 'github-alt', 'folder-o', 'folder-open-o', 'smile-o', 'frown-o',
		// 'meh-o', 'gamepad', 'keyboard-o', 'flag-o', 'flag-checkered',
		// 'terminal', 'code', 'reply-all', 'mail-reply-all', 'star-half-o',
		// 'location-arrow', 'crop', 'code-fork', 'chain-broken', 'question',
		// 'info', 'exclamation', 'superscript', 'subscript', 'eraser',
		// 'puzzle-piece', 'microphone', 'microphone-slash', 'shield',
		// 'calendar-o', 'fire-extinguisher', 'rocket', 'maxcdn',
		// 'chevron-circle-left', 'chevron-circle-right', 'chevron-circle-up',
		// 'chevron-circle-down', 'html5', 'css3', 'anchor', 'unlock-alt',
		// 'bullseye', 'ellipsis-h', 'ellipsis-v', 'rss-square', 'play-circle',
		// 'ticket', 'minus-square', 'minus-square-o', 'level-up', 'level-down',
		// 'check-square', 'pencil-square', 'external-link-square',
		// 'share-square', 'compass', 'caret-square-o-down', 'caret-square-o-up',
		// 'caret-square-o-right', 'eur', 'gbp', 'usd', 'inr', 'jpy', 'rub',
		// 'krw', 'btc', 'file', 'file-text', 'sort-alpha-asc', 'sort-alpha-desc',
		// 'sort-amount-asc', 'sort-amount-desc', 'sort-numeric-asc',
		// 'sort-numeric-desc', 'thumbs-up', 'thumbs-down', 'youtube-square',
		// 'youtube', 'xing', 'xing-square', 'youtube-play', 'dropbox',
		// 'stack-overflow', 'instagram', 'flickr', 'adn', 'bitbucket',
		// 'bitbucket-square', 'tumblr', 'tumblr-square', 'long-arrow-down',
		// 'long-arrow-up', 'long-arrow-left', 'long-arrow-right', 'apple',
		// 'windows', 'android', 'linux', 'dribbble', 'skype', 'foursquare',
		// 'trello', 'female', 'male', 'gittip', 'sun-o', 'moon-o', 'archive',
		// 'bug', 'vk', 'weibo', 'renren', 'pagelines', 'stack-exchange',
		// 'arrow-circle-o-right', 'arrow-circle-o-left', 'caret-square-o-left',
		// 'dot-circle-o', 'wheelchair', 'vimeo-square', 'try', 'plus-square-o',
	);


	/**
	 * Get Font Awesome icon names
	 *
	 * @return array
	 */
	public static function get_icon_names() {
		return array_combine( self::$icons, self::$icons );
	}


	/**
	 * Get options data
	 *
	 * @return array
	 */
	public static function get() {
		return array(
			'page_title'        => __( 'tinyCoffee Options', 'tinycoffee' ),
			'page_description'  => false,
			'menu_title'        => __( 'tinyCoffee', 'tinycoffee' ),
			'permission'        => 'manage_options',
			'menu_slug'         => 'tiny_coffee_options',
			'option_name'       => 'tiny_coffee_options',
			'plugin_path'       => 'tiny_coffee_options',
			'defaults'          => array(
				'coffee_title'      => __( 'Buy me a cup of coffee', 'tinycoffee' ),
				'coffee_text'       => __( 'A ridiculous amount of coffee was consumed in the process of building this project. Add some fuel if you\'d like to keep me going!', 'tinycoffee' ),
				'coffee_icon'       => 'coffee',
				'coffee_currency'   => '€%s',
				'coffee_price'      => '2',
				'coffee_hash'       => '#coffee',
				'coffee_default'    => 2,
				'paypal_email'      => '',
				'paypal_currency'   => 'EUR',
				'paypal_exchange'   => 1,
				'paypal_text'       => sprintf( _x( 'A coffee for %s', 'Blog Title', 'tinycoffee' ), get_bloginfo( 'title' ) ),
				'paypal_testing'    => false,
				'callback_success'  => get_bloginfo( 'url' ),
				'callback_cancel'   => get_bloginfo( 'url' ),
				'callback_auto'			=> false,
				'callback_activate' => array(
					'template_tag' => true,
					'widget'       => true,
					'modal_view'   => true,
					'shortcode'    => true
				),
			),
			'section'           => array(
				array(
					'slug'  => 'coffee',
					'title' => __( 'Main Settings', 'tinycoffee' ),
					'field' => array(
						array(
							'slug'        => 'title',
							'title'       => __( 'Default title', 'tinycoffee' ),
							'type'        => 'text'
						),
						array(
							'slug'        => 'text',
							'title'       => __( 'Default text', 'tinycoffee' ),
							'type'        => 'textarea'
						),
						array(
							'slug'        => 'icon',
							'title'       => __( 'Default icon', 'tinycoffee' ),
							'type'        => 'select',
							'description' => sprintf(
								__( 'You can choose any %s icon', 'tinycoffee' ),
								'<a href="http://fontawesome.io/icons/" target="_blank">FontAwesome</a>'
							),
							'options'     => array(
								'list' => self::get_icon_names(),
							),
						),
						array(
							'slug'        => 'hash',
							'title'       => __( 'Hash', 'tinycoffee' ),
							'type'        => 'text',
						),
						array(
							'slug'        => 'currency',
							'title'       => __( 'Currency template', 'tinycoffee' ),
							'type'        => 'text',
						),
						array(
							'slug'        => 'price',
							'title'       => __( 'Coffee price', 'tinycoffee' ),
							'type'        => 'text',
							'description' => __( 'How much is a single cup of your favorite coffee?', 'tinycoffee' ),
						),
						array(
							'slug'        => 'default',
							'title'       => __( 'Default amount', 'tinycoffee' ),
							'type'        => 'number',
							'description' => __( 'How many cups are selected by default', 'tinycoffee' ),
							'options'			=> array(
								'min' => 1,
								'max' => 20,
								'step' => 1
							),
						),
					),
				),
				array(
					'slug'  => 'paypal',
					'title' => __( 'Paypal Settings', 'tinycoffee' ),
					'field' => array(
						array(
							'slug'  => 'email',
							'title' => __( 'Paypal username', 'tinycoffee' ),
							'type'  => 'text'
						),
						array(
							'slug'  => 'currency',
							'title' => __( 'Paypal currency', 'tinycoffee' ),
							'type'  => 'text'
						),
						array(
							'slug'  => 'exchange',
							'title' => __( 'Exchange rate', 'tinycoffee' ),
							'type'  => 'text'
						),
						array(
							'slug'  => 'text',
							'title' => __( 'Payment text', 'tinycoffee' ),
							'type'  => 'text'
						),
						array(
							'slug'  => 'testing',
							'title' => __( 'Sandbox mode', 'tinycoffee' ),
							'label' => __( 'Enable', 'tinycoffee' ),
							'type'  => 'checkbox'
						),
					)
				),
				array(
					'slug'  => 'callback',
					'title' => __( 'Callback Settings', 'tinycoffee' ),
					'field' => array(
						array(
							'slug'    => 'success',
							'title'   => __( 'Success callback', 'tinycoffee' ),
							'type'    => 'text'
						),
						array(
							'slug'    => 'cancel',
							'title'   => __( 'Cancel callback', 'tinycoffee' ),
							'type'    => 'text'
						),
						array(
							'slug'    => 'auto',
							'title'   => __( 'Redirect to the same page', 'tinycoffee' ),
							'type'    => 'checkbox',
						),
						array(
							'slug'    => 'activate',
							'title'   => __( 'Activate', 'tinycoffee' ),
							'type'    => 'checkbox_list',
							'options' => array(
								'list' => array(
									'template_tag' => __( 'Template tag', 'tinycoffee' ),
									'shortcode'    => __( 'Shortcode', 'tinycoffee' ),
									'modal_view'   => __( 'Modal dialog', 'tinycoffee' ),
									'widget'       => __( 'Widget', 'tinycoffee' ),
								),
							),
						),
					),
				),
			),
		);
	}
}
